#include <string>
#include <fstream>
#include <sstream>

#include "InvertedIndex.h"


void load(const char* file)
{
    invertedindex ii(file);
    ii.load();
}

invertedindex::invertedindex(const std::string f)
:_file(f), _index()
{
}

void invertedindex::load()
{
    std::fstream in_file (_file.c_str());
    std::string one_line;
		unsigned long line_counter = 0;

    while (!in_file.eof())
    {
    		++line_counter;
				getline (in_file, one_line);
				std::istringstream string_split(one_line);
        while (string_split)
        {
        		std::string word;
        		string_split >> word;

            std::map<std::string, std::list<unsigned long> >::iterator iter = _index.find(word);
            if (iter == _index.end())
            {
                std::list <unsigned long> occurrence_list;
                occurrence_list.push_back(line_counter);
                _index[word] = occurrence_list;
            }
            else
            {
                iter->second.push_back(line_counter);
            }
        }
    }
}


